Index: src/includes/classes/Smarty/sysplugins/smarty_internal_template.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_template.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_template.php	(revision )
@@ -669,65 +338,34 @@
      *
      * @param string $property_name property name
      *
+     * @return mixed|Smarty_Template_Cached
      * @throws SmartyException
      */
     public function __get($property_name)
     {
         switch ($property_name) {
-            case 'source':
-                if (strlen($this->template_resource) == 0) {
-                    throw new SmartyException('Missing template name');
-                }
-                $this->source = Smarty_Resource::source($this);
-                // cache template object under a unique ID
-                // do not cache eval resources
-                if ($this->source->type != 'eval') {
-                    if ($this->smarty->allow_ambiguous_resources) {
-                        $_templateId = $this->source->unique_resource . $this->cache_id . $this->compile_id;
-                    } else {
-                        $_templateId = $this->smarty->joined_template_dir . '#' . $this->template_resource . $this->cache_id . $this->compile_id;
-                    }
-
-                    if (isset($_templateId[150])) {
-                        $_templateId = sha1($_templateId);
-                    }
-                    $this->smarty->template_objects[$_templateId] = $this;
-                }
-
-                return $this->source;
-
             case 'compiled':
-                $this->compiled = $this->source->getCompiled($this);
-
+                $this->loadCompiled();
                 return $this->compiled;
 
             case 'cached':
-                if (!class_exists('Smarty_Template_Cached')) {
-                    include SMARTY_SYSPLUGINS_DIR . 'smarty_cacheresource.php';
-                }
-                $this->cached = new Smarty_Template_Cached($this);
-
+                $this->loadCached();
                 return $this->cached;
 
             case 'compiler':
-                $this->smarty->loadPlugin($this->source->compiler_class);
-                $this->compiler = new $this->source->compiler_class($this->source->template_lexer_class, $this->source->template_parser_class, $this->smarty);
-
+                $this->loadCompiler();
                 return $this->compiler;
-
-            // FIXME: routing of template -> smarty attributes
             default:
+                // Smarty property ?
                 if (property_exists($this->smarty, $property_name)) {
                     return $this->smarty->$property_name;
                 }
         }
-
         throw new SmartyException("template property '$property_name' does not exist.");
     }
 
     /**
      * Template data object destructor
-
      */
     public function __destruct()
     {
Index: src/includes/classes/Smarty/plugins/modifiercompiler.count_characters.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/modifiercompiler.count_characters.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/modifiercompiler.count_characters.php	(revision )
@@ -1,0 +1,0 @@
Index: src/includes/classes/Smarty/Autoloader.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/Autoloader.php	(revision )
+++ src/includes/classes/Smarty/Autoloader.php	(revision )
@@ -0,0 +1,124 @@
+<?php
+/**
+ * Smarty Autoloader
+ *
+ * @package    Smarty
+ */
+
+/**
+ * Smarty Autoloader
+ *
+ * @package    Smarty
+ * @author     Uwe Tews
+ *             Usage:
+ *             require_once '...path/Autoloader.php';
+ *             Smarty_Autoloader::register();
+ *             $smarty = new Smarty();
+ *             Note:       This autoloader is not needed if you use Composer.
+ *             Composer will automatically add the classes of the Smarty package to it common autoloader.
+ */
+class Smarty_Autoloader
+{
+    /**
+     * Filepath to Smarty root
+     *
+     * @var string
+     */
+    public static $SMARTY_DIR = '';
+
+    /**
+     * Filepath to Smarty internal plugins
+     *
+     * @var string
+     */
+    public static $SMARTY_SYSPLUGINS_DIR = '';
+
+    /**
+     * Array with Smarty core classes and their filename
+     *
+     * @var array
+     */
+    public static $rootClasses = array('smarty' => 'Smarty.class.php', 'smartybc' => 'SmartyBC.class.php',);
+
+    /**
+     * Registers Smarty_Autoloader backward compatible to older installations.
+     *
+     * @param bool $prepend Whether to prepend the autoloader or not.
+     */
+    public static function registerBC($prepend = false)
+    {
+        /**
+         * register the class autoloader
+         */
+        if (!defined('SMARTY_SPL_AUTOLOAD')) {
+            define('SMARTY_SPL_AUTOLOAD', 0);
+        }
+        if (SMARTY_SPL_AUTOLOAD &&
+            set_include_path(get_include_path() . PATH_SEPARATOR . SMARTY_SYSPLUGINS_DIR) !== false
+        ) {
+            $registeredAutoLoadFunctions = spl_autoload_functions();
+            if (!isset($registeredAutoLoadFunctions['spl_autoload'])) {
+                spl_autoload_register();
+            }
+        } else {
+            self::register($prepend);
+        }
+    }
+
+    /**
+     * Registers Smarty_Autoloader as an SPL autoloader.
+     *
+     * @param bool $prepend Whether to prepend the autoloader or not.
+     */
+    public static function register($prepend = false)
+    {
+        self::$SMARTY_DIR = defined('SMARTY_DIR') ? SMARTY_DIR : dirname(__FILE__) . DIRECTORY_SEPARATOR;
+        self::$SMARTY_SYSPLUGINS_DIR = defined('SMARTY_SYSPLUGINS_DIR') ? SMARTY_SYSPLUGINS_DIR :
+            self::$SMARTY_DIR . 'sysplugins' . DIRECTORY_SEPARATOR;
+        if (version_compare(phpversion(), '5.3.0', '>=')) {
+            spl_autoload_register(array(__CLASS__, 'autoload'), true, $prepend);
+        } else {
+            spl_autoload_register(array(__CLASS__, 'autoload'));
+        }
+    }
+
+    /**
+     * Handles auto loading of classes.
+     *
+     * @param string $class A class name.
+     */
+    public static function autoload($class)
+    {
+        $_class = strtolower($class);
+        $file = self::$SMARTY_SYSPLUGINS_DIR . $_class . '.php';
+        if (strpos($_class, 'smarty_internal_') === 0) {
+            if (strpos($_class, 'smarty_internal_compile_') === 0) {
+                if (is_file($file)) {
+                    require $file;
+                }
+                return;
+            }
+            @include $file;
+            return;
+        }
+        if (preg_match('/^(smarty_(((template_(source|config|cache|compiled|resource_base))|((cached|compiled)?resource)|(variable|security)))|(smarty(bc)?)$)/',
+                       $_class, $match)) {
+            if (!empty($match[3])) {
+                @include $file;
+                return;
+            } elseif (!empty($match[9]) && isset(self::$rootClasses[$_class])) {
+                $file = self::$rootClasses[$_class];
+                require $file;
+                return;
+            }
+        }
+        if (0 !== strpos($_class, 'smarty')) {
+            return;
+        }
+        if (is_file($file)) {
+            require $file;
+            return;
+        }
+        return;
+    }
+}
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_loadplugin.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_loadplugin.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_loadplugin.php	(revision )
@@ -0,0 +1,111 @@
+<?php
+
+/**
+ * Smarty Extension Loadplugin
+ *
+ * $smarty->loadPlugin() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_LoadPlugin
+{
+    /**
+     * Cache of searched plugin files
+     *
+     * @var array
+     */
+    public $plugin_files = array();
+
+    /**
+     * Takes unknown classes and loads plugin files for them
+     * class name format: Smarty_PluginType_PluginName
+     * plugin filename format: plugintype.pluginname.php
+     *
+     * @param \Smarty $smarty
+     * @param  string $plugin_name class plugin name to load
+     * @param  bool   $check       check if already loaded
+     *
+     * @return bool|string
+     * @throws \SmartyException
+     */
+    public function loadPlugin(Smarty $smarty, $plugin_name, $check)
+    {
+        // if function or class exists, exit silently (already loaded)
+        if ($check && (is_callable($plugin_name) || class_exists($plugin_name, false))) {
+            return true;
+        }
+        if (!preg_match('#^smarty_((internal)|([^_]+))_(.+)$#i', $plugin_name, $match)) {
+            throw new SmartyException("plugin {$plugin_name} is not a valid name format");
+        }
+        if (!empty($match[2])) {
+            $file = SMARTY_SYSPLUGINS_DIR . strtolower($plugin_name) . '.php';
+            if (isset($this->plugin_files[$file])) {
+                if ($this->plugin_files[$file] !== false) {
+                    return $this->plugin_files[$file];
+                } else {
+                    return false;
+                }
+            } else {
+                if (is_file($file)) {
+                    $this->plugin_files[$file] = $file;
+                    require_once($file);
+                    return $file;
+                } else {
+                    $this->plugin_files[$file] = false;
+                    return false;
+                }
+            }
+        }
+        // plugin filename is expected to be: [type].[name].php
+        $_plugin_filename = "{$match[1]}.{$match[4]}.php";
+        $_lower_filename = strtolower($_plugin_filename);
+        if (isset($this->plugin_files)) {
+            if (isset($this->plugin_files['plugins_dir'][$_lower_filename])) {
+                if (!$smarty->use_include_path || $this->plugin_files['plugins_dir'][$_lower_filename] !== false) {
+                    return $this->plugin_files['plugins_dir'][$_lower_filename];
+                }
+            }
+            if (!$smarty->use_include_path || $smarty->ext->_getIncludePath->isNewIncludePath($smarty)) {
+                unset($this->plugin_files['include_path']);
+            } else {
+                if (isset($this->plugin_files['include_path'][$_lower_filename])) {
+                    return $this->plugin_files['include_path'][$_lower_filename];
+                }
+            }
+        }
+        $_file_names = array($_plugin_filename);
+        if ($_lower_filename != $_plugin_filename) {
+            $_file_names[] = $_lower_filename;
+        }
+        $_p_dirs = $smarty->getPluginsDir();
+        if (!isset($this->plugin_files['plugins_dir'][$_lower_filename])) {
+            // loop through plugin dirs and find the plugin
+            foreach ($_p_dirs as $_plugin_dir) {
+                foreach ($_file_names as $name) {
+                    $file = $_plugin_dir . $name;
+                    if (is_file($file)) {
+                        $this->plugin_files['plugins_dir'][$_lower_filename] = $file;
+                        require_once($file);
+                        return $file;
+                    }
+                    $this->plugin_files['plugins_dir'][$_lower_filename] = false;
+                }
+            }
+        }
+        if ($smarty->use_include_path) {
+            foreach ($_file_names as $_file_name) {
+                // try PHP include_path
+                $file = $smarty->ext->_getIncludePath->getIncludePath($_p_dirs, $_file_name, $smarty);
+                $this->plugin_files['include_path'][$_lower_filename] = $file;
+                if ($file !== false) {
+                    require_once($file);
+                    return $file;
+                }
+            }
+        }
+        // no plugin loaded
+        return false;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_parsetree_dqcontent.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_parsetree_dqcontent.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_parsetree_dqcontent.php	(revision )
@@ -0,0 +1,42 @@
+<?php
+/**
+ * Smarty Internal Plugin Templateparser Parse Tree
+ * These are classes to build parse tree  in the template parser
+ *
+ * @package    Smarty
+ * @subpackage Compiler
+ * @author     Thue Kristensen
+ * @author     Uwe Tews
+ */
+
+/**
+ * Raw chars as part of a double quoted string.
+ *
+ * @package    Smarty
+ * @subpackage Compiler
+ * @ignore
+ */
+class Smarty_Internal_ParseTree_DqContent extends Smarty_Internal_ParseTree
+{
+    /**
+     * Create parse tree buffer with string content
+     *
+     * @param string $data string section
+     */
+    public function __construct($data)
+    {
+        $this->data = $data;
+    }
+
+    /**
+     * Return content as double quoted string
+     *
+     * @param \Smarty_Internal_Templateparser $parser
+     *
+     * @return string doubled quoted string
+     */
+    public function to_smarty_php(Smarty_Internal_Templateparser $parser)
+    {
+        return '"' . $this->data . '"';
+    }
+}
Index: src/includes/classes/Smarty/plugins/modifiercompiler.noprint.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/modifiercompiler.noprint.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/modifiercompiler.noprint.php	(revision )
@@ -1,0 +1,0 @@
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_unregisterresource.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_unregisterresource.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_unregisterresource.php	(revision )
@@ -0,0 +1,40 @@
+<?php
+
+/**
+ * Smarty Method UnregisterResource
+ *
+ * Smarty::unregisterResource() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_UnregisterResource
+{
+    /**
+     * Valid for Smarty and template object
+     *
+     * @var int
+     */
+    public $objMap = 3;
+
+    /**
+     * Registers a resource to fetch a template
+     *
+     * @api  Smarty::unregisterResource()
+     * @link http://www.smarty.net/docs/en/api.unregister.resource.tpl
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     * @param  string                                                         $type     name of resource type
+      *
+     * @return \Smarty|\Smarty_Internal_Template
+     */
+    public function unregisterResource(Smarty_Internal_TemplateBase $obj, $type)
+    {
+        $smarty = isset($obj->smarty) ? $obj->smarty : $obj;
+        if (isset($smarty->registered_resources[$type])) {
+            unset($smarty->registered_resources[$type]);
+        }
+        return $obj;
+    }
+}
\ No newline at end of file
